## flightgear 2020.3.18+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

include (CheckFunctionExists)
include (CheckVariableExists)
include (CheckCSourceCompiles)
include (CheckCXXSourceCompiles)
include (CheckIncludeFile)
include (CheckIncludeFileCXX)

if(COMMAND cmake_policy)
   if(POLICY CMP0054)
       cmake_policy(SET CMP0054 NEW)
   endif()
   # Mac RPATH policy
   if(POLICY CMP0042)
       cmake_policy(SET CMP0042 NEW)
   endif()

    # AUTOMOC/AUTOUIC on generated files policy. Since we only
    # generate resource files with fgrcc which don't use Qt,
    # we set those files source property. See the help for this
    # policy for more info
    if(POLICY CMP0071)
        cmake_policy(SET CMP0071 NEW)
    endif()

    # OpenGL VND policy : use the old definition for now, until we can audit this
    if(POLICY CMP0072)
        cmake_policy(SET CMP0072 OLD)
    endif()
endif()

message("CMAKE Build type: ${CMAKE_BUILD_TYPE}")
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

if(NOT FG_BUILD_TYPE)
  message(STATUS "Setting build type to 'Dev' as none was specified.")
  set(FG_BUILD_TYPE Dev CACHE STRING "Choose the FlightGear build type" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE FG_BUILD_TYPE PROPERTY STRINGS "Dev" "Nightly" "Release")
endif()

if(APPLE)
	set(CMAKE_INSTALL_RPATH "@loader_path/../Frameworks")
	# when building, don't use the install RPATH already
	# (but later on when installing)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
endif()

# let's use & require C++11 - note these are only functional with CMake 3.1
# we do manual fallbacks for CMake 3.0 in the compilers section
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

project(FlightGear)

# Define SRC_PARENT_DIR as the parent directory of the project source directory
get_filename_component(SRC_PARENT_DIR ${PROJECT_SOURCE_DIR} DIRECTORY)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'fgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../fgbuild && cd ../fgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)

include(GNUInstallDirs)
# System detection/default settings
include( DetectDistro )
include( DetectBrowser )
include( ExportDebugSymbols )
set(CMAKE_DEBUG_POSTFIX          "d" CACHE STRING "add a postfix, usually d on windows")
set(CMAKE_RELEASE_POSTFIX        ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_RELWITHDEBINFO_POSTFIX ""  CACHE STRING "add a postfix, usually empty on windows")
set(CMAKE_MINSIZEREL_POSTFIX     ""  CACHE STRING "add a postfix, usually empty on windows")

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ flightgear-version versionFile)
if (NOT versionFile)
    message(FATAL_ERROR "Unable to determine FlightGear version. Version file is missing.")
endif()
string(STRIP "${versionFile}" FLIGHTGEAR_VERSION)
# add a dependency on the version file
set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS version)

# FlightGear packaging (to build a source tarball)
include( ConfigureCPack )

# FlightGear base package path
if (FG_DATA_DIR)
    message(STATUS "Using explicit data directory for base package: ${FG_DATA_DIR}")
elseif(IS_DIRECTORY "${SRC_PARENT_DIR}/fgdata")
    set(FG_DATA_DIR "${SRC_PARENT_DIR}/fgdata")
    message(STATUS "Using data directory for base package: ${FG_DATA_DIR}")
else()
    set(FG_DATA_DIR "${CMAKE_INSTALL_PREFIX}/lib/FlightGear" CACHE PATH "Default location where data files are located")
    message(STATUS "Using default data directory for base package:  ${FG_DATA_DIR}")
endif()

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

#####################################################################################
# Configure library search paths
#####################################################################################

IF(APPLE)
    set(EVENT_INPUT_DEFAULT 1)

    find_library(CORESERVICES_LIBRARY CoreServices)
    find_library(COCOA_LIBRARY Cocoa)
    list(APPEND PLATFORM_LIBS ${COCOA_LIBRARY} ${CORESERVICES_LIBRARY})
elseif(WIN32)
    set(EVENT_INPUT_DEFAULT 1)
    list(APPEND PLATFORM_LIBS "Shlwapi.lib" "Version.lib")

    # disabling for now so we don' bundle an outdatd UCRT
 #   set(CMAKE_INSTALL_SYSTEM_RUNTIME_DESTINATION "bin")
 #   set(CMAKE_INSTALL_UCRT_LIBRARIES TRUE)
 #   include(InstallRequiredSystemLibraries)
  #  MESSAGE("Installing: ${CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS}")

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR
	${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD" OR
	${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    find_package(Threads REQUIRED)
    find_package(X11 REQUIRED)

    set(USE_DBUS_DEFAULT 1)

    find_package(UDev QUIET)
    if(UDEV_FOUND)
        set(EVENT_INPUT_DEFAULT 1)
    endif(UDEV_FOUND)

    find_package(Speex)
    find_package(Speexdsp)
    if(SPEEX_FOUND AND SPEEXDSP_FOUND)
        set(SYSTEM_SPEEX_DEFAULT 1)
    endif(SPEEX_FOUND AND SPEEXDSP_FOUND)

    find_package(Gsm)
    if(GSM_FOUND)
        set(SYSTEM_GSM_DEFAULT 1)
    endif(GSM_FOUND)

    find_package(Flite)
    if(FLITE_FOUND)
        set(SYSTEM_FLITE_DEFAULT 1)
    endif()

    find_package(HtsEngine)
    if(HTS_ENGINE_FOUND)
        set(SYSTEM_HTS_ENGINE_DEFAULT 1)
    endif()
endif()

# FlightGear build options
option(LOGGING           "Set to ON to build FlightGear with logging support (default)" ON)
option(JSBSIM_TERRAIN    "Set to ON to build FlightGear with JSBSim terrain handling code" ON)
option(SP_FDMS           "Set to ON to build FlightGear with special-purpose FDMs" ON)
option(ENABLE_UIUC_MODEL "Set to ON to build FlightGear with UIUCModel FDM" ON)
option(ENABLE_LARCSIM    "Set to ON to build FlightGear with LaRCsim FDM" ON)
option(ENABLE_YASIM      "Set to ON to build FlightGear with YASIM FDM (default)" ON)
option(ENABLE_JSBSIM     "Set to ON to build FlightGear with JSBSim FDM (default)" ON)
option(EVENT_INPUT       "Set to ON to build FlightGear with event-based Input support" ${EVENT_INPUT_DEFAULT})
option(ENABLE_RTI        "Set to ON to build FlightGear with RTI support" OFF)
option(ENABLE_PROFILE    "Set to ON to build FlightGear with gperftools profiling support" OFF)
option(SYSTEM_SQLITE     "Set to ON to build FlightGear with the system's SQLite3 library" OFF)
option(ENABLE_IAX        "Set to ON to build FlightGear with IAXClient/fgcom built-in (default)" ON)
option(USE_DBUS          "Set to ON to build FlightGear with DBus screensaver interaction (default on Linux)" ${USE_DBUS_DEFAULT})
option(SYSTEM_SPEEX      "Set to ON to build IAXClient with the system's speex and speexdsp library" ${SYSTEM_SPEEX_DEFAULT})
option(SYSTEM_GSM        "Set to ON to build IAXClient with the system's GSM library" ${SYSTEM_GSM_DEFAULT})
option(SYSTEM_FLITE      "Set to ON to build Flightgear with the system's Flite library" ${SYSTEM_FLITE_DEFAULT})
option(SYSTEM_HTS_ENGINE "Set to ON to build Flightgear with the system's HTS Engine library" ${SYSTEM_HTS_ENGINE_DEFAULT})
option(SYSTEM_CPPUNIT    "Set to ON to build Flightgear with the system's CppUnit library")

# additional utilities
option(ENABLE_FGELEV     "Set to ON to build the fgelev application (default)" ON)
option(WITH_FGPANEL      "Set to ON to build the fgpanel application (default)" ON)
option(ENABLE_FGVIEWER   "Set to ON to build the fgviewer application (default)" ON)
option(ENABLE_GPSSMOOTH  "Set to ON to build the GPSsmooth application (default)" ON)
option(ENABLE_TERRASYNC  "Set to ON to build the terrasync application (default)" ON)
option(ENABLE_FGJS       "Set to ON to build the fgjs application (default)" ON)
option(ENABLE_JS_DEMO    "Set to ON to build the js_demo application (default)" ON)
option(ENABLE_METAR      "Set to ON to build the metar application (default)" ON)
option(ENABLE_STGMERGE   "Set to ON to build the stgmerge application (default)" OFF)
option(ENABLE_FGCOM      "Set to ON to build the FGCom application (default)" ON)
option(ENABLE_QT         "Set to ON to build the internal Qt launcher" ON)
option(ENABLE_TRAFFIC    "Set to ON to build the external traffic generator modules" ON)
option(ENABLE_FGQCANVAS  "Set to ON to build the Qt-based remote canvas application" OFF)
option(ENABLE_DEMCONVERT "Set to ON to build the dem conversion tool (default)" ON)
option(ENABLE_HID_INPUT  "Set to ON to build HID-based input code" ${EVENT_INPUT_DEFAULT})
option(ENABLE_PLIB_JOYSTICK  "Set to ON to enable legacy joystick code (default)" ON)
option(ENABLE_COMPOSITOR "Set to ON to enable the Compositor-based Viewer" OFF)
option(ENABLE_SWIFT      "Set to ON to build the swift module" ON)


# Test-suite options.
option(ENABLE_AUTOTESTING "Set to ON to execute the test suite after building the test_suite target (default)" ON)

include (DetectArch)

# when building an OSG with commit 15ec7e2ae7a8b983ecc44e1ce7363a9a9fa7da95
# applied, we can use better link options
option(OSG_FSTREAM_EXPORT_FIXED "Set to ON if the osgDB fstream export patch is applied" OFF)

if(LOGGING)
    # nothing
else()
    set(FG_NDEBUG 1)
endif()

if(JSBSIM_TERRAIN)
   set(JSBSIM_USE_GROUNDREACTIONS 1)
endif()

if(SP_FDMS)
    set(ENABLE_SP_FDM 1)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
    include_directories(${PROJECT_SOURCE_DIR}/3rdparty/iaxclient/lib/libspeex/include)
endif()

if(ENABLE_FGCOM)
  set(ENABLE_IAX 1)
  include_directories(${PROJECT_SOURCE_DIR}/3rdparty/iaxclient/lib ) # for iaxclient.h
endif()

# Setup MSVC 3rd party directories
include( ConfigureMsvc3rdParty )

if(EVENT_INPUT)
    if(APPLE)
      add_definitions(-DWITH_EVENTINPUT)
      find_library(IOKIT_FRAMEWORK IOKit)
      list(APPEND EVENT_INPUT_LIBRARIES ${IOKIT_FRAMEWORK})
    elseif(CMAKE_SYSTEM_NAME MATCHES "Linux|FreeBSD|OpenBSD")
        if(NOT UDEV_FOUND)
            message(WARNING "UDev not found, event input is disabled!")
            set(EVENT_INPUT 0)

            # HIDraw backend for hidapi also needs UDev, so also force
            # HID-input to off in this scenario
            set(ENABLE_HID_INPUT 0)
        else()
            add_definitions(-DWITH_EVENTINPUT)
            set(EVENT_INPUT_LIBRARIES ${UDEV_LIBRARIES})
            message(STATUS "event-based input enabled. Using ${UDEV_LIBRARIES}")
        endif()
    else()
        add_definitions(-DWITH_EVENTINPUT)
    endif()

    if (ENABLE_HID_INPUT)
        message(STATUS "Enabling HID-API input")
        list(APPEND EVENT_INPUT_LIBRARIES hidapi)
    endif()
endif(EVENT_INPUT)

if (ENABLE_SWIFT)
# DBUS

    # our local FindDBus.cmake file uses pkg-config on non-Windows
    # we want to ensure our local prefixes are searched, so set this
    set(PKG_CONFIG_USE_CMAKE_PREFIX_PATH 1)

    # unfortunately CMAKE_INSTALL_PREFIX is not searched, so add that manually
    list(APPEND CMAKE_PREFIX_PATH ${CMAKE_INSTALL_PREFIX})

    find_package(DBus)

    #libevent
    find_package(LibEvent)

    if (DBUS_FOUND AND LIBEVENT_FOUND)

=== scripts/CMakeLists.txt ===
# Install bash and zsh completion files.
#
# The install path is not detected at runtime (contrary to what the
# bash-completion documentation suggests, see
# <https://github.com/scop/bash-completion/blob/master/README.md>) to account
# for those cases where the FlightGear installation prefix is not /usr.
# See <https://sourceforge.net/p/flightgear/flightgear/merge-requests/96/#e6f4>
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    install(FILES completion/fg-completion.bash DESTINATION share/bash-completion/completions RENAME fgfs)
    install(FILES completion/fg-completion.zsh DESTINATION share/zsh/site-functions RENAME _fgfs)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

=== utils/CMakeLists.txt ===
# win32 is just excluded because of not having argument parsing there ...
if(RTI_FOUND AND NOT WIN32)
    add_subdirectory(fgai)
endif()

if(ENABLE_FGELEV)
    add_subdirectory(fgelev)
endif()

if(WITH_FGPANEL)
    add_subdirectory(fgpanel)
endif()

if(ENABLE_FGVIEWER)
    add_subdirectory(fgviewer)
endif()

if(ENABLE_GPSSMOOTH)
    add_subdirectory(GPSsmooth)
endif()

if(ENABLE_TERRASYNC)
    add_subdirectory(TerraSync)
endif()

if(ENABLE_FGCOM)
    add_subdirectory(fgcom)
endif()

if(ENABLE_STGMERGE)
    add_subdirectory(stgmerge)
endif()

if(ENABLE_TRAFFIC)
    add_subdirectory(traffic)
endif()

if (ENABLE_FGQCANVAS)
    if(Qt5Core_VERSION VERSION_EQUAL 5.7 OR Qt5Core_VERSION VERSION_GREATER 5.7)
        add_subdirectory(fgqcanvas)
    else()
        message(WARNING "FGQCanvas enabled, but Qt >= 5.7 is required for this feature")
    endif()
endif()

if(ENABLE_DEMCONVERT)
    if(GDALFOUND)
        add_subdirectory(demconvert)
    endif()
endif()

=== 3rdparty/flite_hts_engine/CMakeLists.txt ===
if (SYSTEM_FLITE)
    set(Flite_FIND_REQUIRED TRUE)
    find_package(Flite)

    include_directories(${FLITE_INCLUDE_DIR})
    message(STATUS "Using Flite includes at: ${FLITE_INCLUDE_DIR}")
    message(STATUS "Using Flite libraries: ${FLITE_LIBRARIES}")
else()
    include_directories(${PROJECT_SOURCE_DIR}/3rdparty/flite_hts_engine/flite/include)
    include_directories(${PROJECT_SOURCE_DIR}/3rdparty/flite_hts_engine/flite/lang/cmulex)
    include_directories(${PROJECT_SOURCE_DIR}/3rdparty/flite_hts_engine/flite/lang/usenglish)

    set(FLITE_SOURCES
        flite/src/hrg/cst_ffeature.c
        flite/src/hrg/cst_item.c
        flite/src/hrg/cst_relation.c
        flite/src/hrg/cst_utterance.c

        flite/src/lexicon/cst_lexicon.c
        flite/src/lexicon/cst_lts.c

        flite/src/regex/cst_regex.c
        flite/src/regex/regexp.c

        flite/src/stats/cst_cart.c

        flite/src/synth/cst_ffeatures.c
        flite/src/synth/cst_phoneset.c
        flite/src/synth/cst_synth.c
        flite/src/synth/cst_utt_utils.c
        flite/src/synth/cst_voice.c
        flite/src/synth/flite.c

        flite/src/utils/cst_alloc.c
        flite/src/utils/cst_error.c
        flite/src/utils/cst_features.c
        flite/src/utils/cst_string.c
        flite/src/utils/cst_tokenstream.c
        flite/src/utils/cst_val.c
        flite/src/utils/cst_val_const.c
        flite/src/utils/cst_val_user.c
    )

    set(FLITE_LANG_SOURCES
        flite/lang/cmu_us_kal/cmu_us_kal.c

        flite/lang/cmulex/cmu_lex.c
        flite/lang/cmulex/cmu_lex_data.c
        flite/lang/cmulex/cmu_lex_entries.c
        flite/lang/cmulex/cmu_lts_model.c
        flite/lang/cmulex/cmu_lts_rules.c
        flite/lang/cmulex/cmu_postlex.c

        flite/lang/usenglish/us_aswd.c
        flite/lang/usenglish/us_expand.c
        flite/lang/usenglish/us_ffeatures.c
        flite/lang/usenglish/us_gpos.c
        flite/lang/usenglish/us_int_accent_cart.c
        flite/lang/usenglish/us_int_tone_cart.c
        flite/lang/usenglish/us_nums_cart.c
        flite/lang/usenglish/us_phoneset.c
        flite/lang/usenglish/us_phrasing_cart.c
        flite/lang/usenglish/us_pos_cart.c
        flite/lang/usenglish/us_text.c
        flite/lang/usenglish/usenglish.c
    )

    if (MSVC)
        add_definitions( -DNO_UNION_INITIALIZATION )
    endif ()
endif()

if (SYSTEM_HTS_ENGINE)
    set(HTS_Engine_FIND_REQUIRED TRUE)
    find_package(HtsEngine)

    include_directories(${HTS_ENGINE_INCLUDE_DIR})
    message(STATUS "Using HTS engine includes for Flite/HTS Engine at: ${HTS_ENGINE_INCLUDE_DIR}")
else()
    include_directories(${PROJECT_SOURCE_DIR}/3rdparty/hts_engine_API/include)
endif()


include_directories(${PROJECT_SOURCE_DIR}/3rdparty/flite_hts_engine/include)

add_definitions(-DFLITE_PLUS_HTS_ENGINE)

add_library(flite_hts STATIC 
    ${FLITE_SOURCES}
    ${FLITE_LANG_SOURCES}
    lib/flite_hts_engine.c
)

target_compile_definitions(flite_hts PRIVATE -DSIZEOF_VOID_P=${CMAKE_SIZEOF_VOID_P})

if (SYSTEM_FLITE)
    target_link_libraries(flite_hts ${FLITE_LIBRARIES})
endif()

=== src/Input/CMakeLists.txt ===
include(FlightGearComponent)

IF(APPLE)
	# no Mac implemention, use HID
elseif(WIN32)
	# no Win32 specific implementation, at least for now
else()
	set(EVENT_INPUT_SOURCES FGLinuxEventInput.cxx)
	set(EVENT_INPUT_HEADERS FGLinuxEventInput.hxx)
endif()

if (ENABLE_HID_INPUT)
	list(APPEND EVENT_INPUT_SOURCES FGHIDEventInput.cxx)
	list(APPEND EVENT_INPUT_HEADERS FGHIDEventInput.hxx)	
endif()

set(SOURCES
	FGButton.cxx
	FGCommonInput.cxx
	FGDeviceConfigurationMap.cxx
	FGEventInput.cxx
	FGKeyboardInput.cxx
	FGMouseInput.cxx
	input.cxx
	)

set(HEADERS
	FGButton.hxx
	FGCommonInput.hxx
	FGDeviceConfigurationMap.hxx
	FGEventInput.hxx
	FGKeyboardInput.hxx
	FGMouseInput.hxx
	input.hxx
	)

if (ENABLE_PLIB_JOYSTICK)
	list(APPEND SOURCES FGJoystickInput.cxx)
	list(APPEND HEADERS FGJoystickInput.hxx)
endif()

if(EVENT_INPUT)
	list(APPEND SOURCES ${EVENT_INPUT_SOURCES})
	list(APPEND HEADERS ${EVENT_INPUT_HEADERS})
	include_directories(${UDEV_INCLUDE_DIR})
endif()

if(ENABLE_FGJS AND ENABLE_PLIB_JOYSTICK)
    set(FGJS_SOURCES
        fgjs.cxx
        jsinput.cxx
        jssuper.cxx
    )

    add_executable(fgjs ${FGJS_SOURCES})
    target_link_libraries(fgjs
		SimGearCore
		PLIBJoystick
    )

    install(TARGETS fgjs RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(ENABLE_JS_DEMO AND ENABLE_PLIB_JOYSTICK)
    add_executable(js_demo js_demo.cxx)
    target_link_libraries(js_demo
        SimGearCore
        PLIBJoystick
    )

    install(TARGETS js_demo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (ENABLE_HID_INPUT)
	if (COMMAND flightgear_test)
		set(HID_INPUT_TEST_SOURCES test_hidinput.cxx FGEventInput.cxx 
			FGCommonInput.cxx FGDeviceConfigurationMap.cxx)

		flightgear_test(hidinput "${HID_INPUT_TEST_SOURCES}")
		target_link_libraries(hidinput ${EVENT_INPUT_LIBRARIES} hidapi)	
	endif()
endif()

flightgear_component(Input "${SOURCES}" "${HEADERS}")

=== src/Main/CMakeLists.txt ===
# CMake module includes.
include(FlightGearComponent)
include(SetupFGFSBundle)
include(SetupFGFSEmbeddedResources)
include(SetupFGFSIncludes)
include(SetupFGFSLibraries)
include(SetupMSVCGrouping)

# Set up the Main FG file sources and headers (excluding bootstrap.cxx and its main() function).
if(MSVC)
    set(MS_RESOURCE_FILE flightgear.rc)
endif(MSVC)

set(SOURCES
    fg_commands.cxx
    fg_init.cxx
    fg_io.cxx
    fg_os_common.cxx
    fg_scene_commands.cxx
    fg_props.cxx
    FGInterpolator.cxx
    globals.cxx
    locale.cxx
    logger.cxx
    main.cxx
    options.cxx
    positioninit.cxx
    screensaver_control.cxx
    subsystemFactory.cxx
    util.cxx
    XLIFFParser.cxx
    sentryIntegration.cxx
    ErrorReporter.cxx
    ${MS_RESOURCE_FILE}
)

set(HEADERS
    AircraftDirVisitorBase.hxx
    fg_commands.hxx
    fg_init.hxx
    fg_io.hxx
    fg_props.hxx
    FGInterpolator.hxx
    globals.hxx
    locale.hxx
    logger.hxx
    main.hxx
    options.hxx
    positioninit.hxx
    screensaver_control.hxx
    subsystemFactory.hxx
    util.hxx
    XLIFFParser.hxx
    sentryIntegration.hxx
    ErrorReporter.hxx
)

flightgear_component(Main "${SOURCES}" "${HEADERS}")

# The main() function.
set(MAIN_SOURCE
    bootstrap.cxx
)

# Set up the embedded resources.
setup_fgfs_embedded_resources()

# Sort the sources and headers for MSVC.
setup_msvc_grouping()

# Additional search paths for includes.
setup_fgfs_includes()

# All sources and headers to be built into fgfs.
get_property(FG_SOURCES GLOBAL PROPERTY FG_SOURCES)
get_property(FG_HEADERS GLOBAL PROPERTY FG_HEADERS)
get_property(EMBEDDED_RESOURCE_SOURCES GLOBAL PROPERTY EMBEDDED_RESOURCE_SOURCES)
get_property(EMBEDDED_RESOURCE_HEADERS GLOBAL PROPERTY EMBEDDED_RESOURCE_HEADERS)

set_source_files_properties(${EMBEDDED_RESOURCE_SOURCES} PROPERTIES GENERATED TRUE)
set_source_files_properties(${EMBEDDED_RESOURCE_HEADERS} PROPERTIES GENERATED TRUE)

# important we pass WIN32 here so the console is optional. Other
# platforms ignore this option. If a console is needed we allocate
# it manually via AllocConsole()
# similarly pass MACOSX_BUNDLE so we generate a .app on Mac
add_executable(fgfs
    WIN32
    MACOSX_BUNDLE
    ${MAIN_SOURCE}
    ${FG_SOURCES}
    ${FG_HEADERS}
    ${EMBEDDED_RESOURCE_SOURCES}
    ${EMBEDDED_RESOURCE_HEADERS}
)

add_dependencies(fgfs buildId embeddedresources)
# explicitly disable automoc for main fgfs target
set_property(TARGET fgfs PROPERTY AUTOMOC OFF)

# MacOSX bundle packaging
if(APPLE)
    setup_fgfs_bundle(fgfs)
endif()

# Set up the target links.
setup_fgfs_libraries(fgfs)
export_debug_symbols(fgfs)

if (APPLE)
    install(TARGETS fgfs BUNDLE DESTINATION .)
else()
    install(TARGETS fgfs RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (TARGET sentry::sentry)
    target_link_libraries(fgfs sentry::sentry)
endif()

if (TARGET sentry_crashpad::crashpad_handler)
    if (APPLE)
        # install inside the bundle
        install(FILES $<TARGET_FILE:sentry_crashpad::crashpad_handler> DESTINATION fgfs.app/Contents/MacOS OPTIONAL)
    else()
        # install in the bin-dir, next to the application binary
        install(FILES $<TARGET_FILE:sentry_crashpad::crashpad_handler> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
    endif()
endif()

if(ENABLE_METAR)
    add_executable(metar metar_main.cxx)
    target_link_libraries(metar
        SimGearScene SimGearCore
        ${PLATFORM_LIBS}
    )

    install(TARGETS metar RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if (MSVC)
  file(TO_NATIVE_PATH "${FG_QT_BIN_DIR}" _qt5_bin_dir_native)
  file(TO_NATIVE_PATH "${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/bin" _msvc_3rdparty_bin_dir)
  file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}" _install_bin_dir)

  set_property(TARGET fgfs PROPERTY
  VS_GLOBAL_LocalDebuggerEnvironment "PATH=${_install_bin_dir};${_msvc_3rdparty_bin_dir};${_qt5_bin_dir_native}")
endif()

if (FG_QT_ROOT_DIR)
    # for QtPlatformHeaders
    target_include_directories(fgfs PRIVATE ${FG_QT_ROOT_DIR}/include)
endif()

=== src/Network/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	ATC-Inputs.cxx
	ATC-Main.cxx
	ATC-Outputs.cxx
	AV400.cxx
	AV400Sim.cxx
	AV400WSim.cxx
	atlas.cxx
	garmin.cxx
	generic.cxx
	HTTPClient.cxx
	DNSClient.cxx
	flarm.cxx
	igc.cxx
	joyclient.cxx
	jsclient.cxx
	lfsglass.cxx
	native.cxx
	native_ctrls.cxx
	native_fdm.cxx
	native_gui.cxx
	nmea.cxx
	opengc.cxx
	props.cxx
	protocol.cxx
	pve.cxx
	ray.cxx
	rul.cxx
	)

set(HEADERS
	ATC-Inputs.hxx
	ATC-Main.hxx
	ATC-Outputs.hxx
	AV400.hxx
	AV400Sim.hxx
	AV400WSim.hxx
	atlas.hxx
	garmin.hxx
	generic.hxx
	HTTPClient.hxx
	DNSClient.hxx
	flarm.hxx
	igc.hxx
	joyclient.hxx
	jsclient.hxx
	lfsglass.hxx
	native.hxx
	native_ctrls.hxx
	native_fdm.hxx
	native_gui.hxx
	nmea.hxx
	opengc.hxx
	props.hxx
	protocol.hxx
	pve.hxx
	ray.hxx
	rul.hxx
	)

if(ENABLE_IAX)
    list(APPEND SOURCES fgcom.cxx)
    list(APPEND HEADERS fgcom.hxx)
endif()
   	
flightgear_component(Network "${SOURCES}" "${HEADERS}")

if(RTI_FOUND)
  add_subdirectory(HLA)
endif()

add_subdirectory(http)

if(ENABLE_SWIFT)
	add_subdirectory(Swift)
endif()

=== src/Sound/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	audioident.cxx
	soundgenerator.cxx
	beacon.cxx
	fg_fx.cxx
	morse.cxx
	sample_queue.cxx
	voice.cxx
	voiceplayer.cxx
	soundmanager.cxx
	VoiceSynthesizer.cxx
	flitevoice.cxx
	)

set(HEADERS
	audioident.hxx
	soundgenerator.hxx
	beacon.hxx
	fg_fx.hxx
	morse.hxx
	sample_queue.hxx
	voice.hxx
	voiceplayer.hxx
	soundmanager.hxx
	VoiceSynthesizer.hxx
	flitevoice.hxx
	)

flightgear_component(Sound "${SOURCES}" "${HEADERS}")

=== utils/demconvert/CMakeLists.txt ===
add_executable(demconvert demconvert.cxx )

target_link_libraries(demconvert
	SimGearScene SimGearCore
    ${GDAL_LIBRARY}
)

install(TARGETS demconvert RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/Network/HLA/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	hla.cxx
	)
	
flightgear_component(HLA "${SOURCES}")

=== test_suite/system_tests/Instrumentation/CMakeLists.txt ===
set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/TestSuite.cxx
    #${CMAKE_CURRENT_SOURCE_DIR}/testgps.cxx
    PARENT_SCOPE
)

set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    #${CMAKE_CURRENT_SOURCE_DIR}/testgps.hxx
    PARENT_SCOPE
)

=== debian/changelog ===
flightgear (1:2020.3.18+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Set upstream metadata fields: Archive, Bug-Database.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing
    See-also: https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
  * Drop transition for old debug package migration.
    Changes-By: lintian-brush
    Fixes: lintian: debug-symbol-migration-possibly-complete
    See-also: https://lintian.debian.org/tags/debug-symbol-migration-possibly-complete.html
  * Update standards version to 4.6.2, no changes needed.
    Changes-By: lintian-brush
    Fixes: lintian: out-of-date-standards-version
    See-also: https://lintian.debian.org/tags/out-of-date-standards-version.html

  [ Dr. Tobias Quathamer ]
  * Add gbp.conf for DEP-14 repository layout
  * New upstream version 2020.3.18+dfsg
    - Refresh patches
    - Update versioned Build-Dependencies to new data packages
  * Use UTC timestamp for reproducibility.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>
    (Closes: #996679)
  * Fix build on riscv64.
    Thanks to Gianfranco Costamagna <locutusofborg@debian.org>
    (Closes: #1025904)
  * Add libevent-dev to support swift for Virtual Air Traffic Networks.
    (Closes: #1035370)
  * Replace obsolete libgl1-mesa-dev with libgl-dev
  * Remove myself from Uploaders

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 09 Jul 2023 14:11:00 +0200

=== debian/control ===
Source: flightgear
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
           Markus Wanner <markus@bluegap.ch>
Section: games
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               flightgear-data-ai (>= 1:2020.3.18~),
               flightgear-data-base (>= 1:2020.3.18~),
               flite1-dev,
               libboost-dev,
               libcurl4-gnutls-dev,
               libdbus-1-dev,
               libevent-dev,
               libexpat1-dev,
               libgl-dev,
               libglu1-mesa-dev,
               libgsm1-dev,
               libhtsengine-dev,
               liblzma-dev,
               libopenal-dev,
               libopenscenegraph-dev,
               libplib-dev,
               libqt5svg5-dev,
               libsimgear-dev (<= 1:2020.3.999),
               libsimgear-dev (>> 1:2020.3.18~),
               libspeex-dev,
               libspeexdsp-dev,
               libsqlite3-dev,
               libudev-dev [linux-any],
               libudns-dev,
               libusbhid-dev [kfreebsd-any],
               libx11-dev,
               qtbase5-dev [!armel !armhf],
               qtbase5-private-dev [!armel !armhf],
               qtdeclarative5-dev [!armel !armhf],
               qtdeclarative5-private-dev [!armel !armhf],
               qttools5-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/flightgear
Vcs-Git: https://salsa.debian.org/debian/flightgear.git
Homepage: https://home.flightgear.org/
Rules-Requires-Root: no

Package: flightgear
Architecture: any
Depends: flightgear-data-all (>= 1:2020.3.18~),
         qml-module-qtquick-window2 [!armel !armhf],
         qml-module-qtquick2 [!armel !armhf],
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: flightgear-phi
Conflicts: metar
Description: Flight Gear Flight Simulator
 FlightGear Flight Simulator (often shortened to FlightGear or FGFS)
 is a sophisticated free, completely open-source flight simulator
 framework, created by volunteers.
 .
 This package contains the runtime binaries.

## flightgear 2020.3.19%2Bdfsg

=== test_suite/simgear_tests/CMakeLists.txt ===
# Add each simgear test category.
foreach( simgear_test_category
        math
        props
        canvas 
        structure
    )

    add_subdirectory(${simgear_test_category})

endforeach( simgear_test_category )


set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    PARENT_SCOPE
)


set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    PARENT_SCOPE
)

=== debian/changelog ===
flightgear (1:2020.3.19+dfsg-1build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 13 Jul 2025 16:21:47 +0300

flightgear (1:2020.3.19+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2020.3.19+dfsg
    - New patch: move checkIORules() to SGPath::NasalIORulesChecker()
      Thanks to Florent Rougon <f.rougon@frougon.net>
  * Update versioned Build-Dependencies to new packages
  * Update Standards-Version to 4.7.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 26 Jan 2025 13:23:50 +0100

flightgear (1:2020.3.18+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add a patch to fix build with 64-bit time_t on 32-bit architectures.
    Closes: #1068038.
  * Bump libsimgear-dev build-dependency to a version that is built with
    the new time_t ABI.

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 07 Apr 2024 12:30:07 +0300

## flightgear 2020.3.19%2bdfsg

=== debian/changelog ===
flightgear (1:2020.3.19+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1096639)
  * Fix FTBFS with CMake 4. (Closes: #1112921)
  * debian/control: Update Homepage.

 -- Adrian Bunk <bunk@debian.org>  Fri, 03 Oct 2025 20:54:04 +0300

## flightgear 2020.3.19+dfsg

=== 3rdparty/mongoose/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	mongoose.c
	)

set(HEADERS
	mongoose.h
	)

flightgear_component(Mongoose "${SOURCES}" "${HEADERS}")

=== src/Canvas/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
  canvas_mgr.cxx
  FGCanvasSystemAdapter.cxx
  gui_mgr.cxx
)

set(HEADERS
  canvas_mgr.hxx
  FGCanvasSystemAdapter.hxx
  gui_mgr.hxx
)

flightgear_component(Canvas "${SOURCES}" "${HEADERS}")

=== src/EmbeddedResources/CMakeLists.txt ===
add_executable(fgrcc fgrcc.cxx fgrcc.hxx)
target_link_libraries(fgrcc SimGearCore ${PLATFORM_LIBS})

# On Windows, make sure fgrcc can be run (it needs third-party libraries) in add_custom_target
if(MSVC)
  set_target_properties(fgrcc PROPERTIES DEBUG_POSTFIX d)
  if(MSVC_3RDPARTY_ROOT AND MSVC_3RDPARTY_DIR)
    set(CMAKE_MSVCIDE_RUN_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/bin)
  else()
    message(FATAL_ERROR
      "Either MSVC_3RDPARTY_ROOT or MSVC_3RDPARTY_DIR is empty or unset")
  endif()
endif()

add_custom_target(
    embeddedresources
    COMMAND
      fgrcc --root=${CMAKE_SOURCE_DIR}
            --output-cpp-file=${CMAKE_BINARY_DIR}/src/EmbeddedResources/FlightGear-resources.cxx
            --init-func-name=initFlightGearEmbeddedResources
            --output-header-file=${CMAKE_BINARY_DIR}/src/EmbeddedResources/FlightGear-resources.hxx
            --output-header-identifier=_FG_FLIGHTGEAR_EMBEDDED_RESOURCES
            ${CMAKE_SOURCE_DIR}/src/EmbeddedResources/FlightGear-resources.xml
    BYPRODUCTS
      ${CMAKE_BINARY_DIR}/src/EmbeddedResources/FlightGear-resources.cxx
      ${CMAKE_BINARY_DIR}/src/EmbeddedResources/FlightGear-resources.hxx
    DEPENDS
      fgrcc ${CMAKE_SOURCE_DIR}/src/EmbeddedResources/FlightGear-resources.xml
)

=== src/Scenery/CMakeLists.txt ===
include(FlightGearComponent)

set(SOURCES
	SceneryPager.cxx
	redout.cxx
	scenery.cxx
	terrain_stg.cxx
	terrain_pgt.cxx
	tilecache.cxx
	tileentry.cxx
	tilemgr.cxx
	)

set(HEADERS
	SceneryPager.hxx
	redout.hxx
	scenery.hxx
	terrain.hxx
	terrain_stg.hxx
	terrain_pgt.hxx
	tilecache.hxx
	tileentry.hxx
	tilemgr.hxx
	)

flightgear_component(Scenery "${SOURCES}" "${HEADERS}")

=== test_suite/gui_tests/CMakeLists.txt ===
# Add each GUI test category.
foreach( gui_test_category
    )

    add_subdirectory(${gui_test_category})

endforeach( gui_test_category )


set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    PARENT_SCOPE
)


set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    PARENT_SCOPE
)

=== utils/TerraSync/CMakeLists.txt ===

#add_executable(terrasync terrasync.cxx)

#target_link_libraries(terrasync SimGearCore)

#install(TARGETS terrasync RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== utils/fgcom/CMakeLists.txt ===
set(name fgcom)

find_package(OpenAL REQUIRED)

# Copy positions.txt content in const char* _positionsData[];
file(READ utils/positions.txt POSITIONS_DATA)
string(REGEX REPLACE "\n" "\"%
    \"" POSITIONS_DATA ${POSITIONS_DATA})
string(REGEX REPLACE "%" "," POSITIONS_DATA ${POSITIONS_DATA})
file(WRITE positions.hxx "const char* _positionsData[] = {
    \"")
file(APPEND positions.hxx ${POSITIONS_DATA})
file(APPEND positions.hxx "\"
};")

if(MSVC)
  set(RESOURCE_FILE fgcom.rc)
endif(MSVC)

set(SOURCES fgcom.cxx)
set(HEADERS fgcom.hxx positions.hxx)

add_executable(${name}
  ${SOURCES}
  ${HEADERS}
  ${RESOURCE_FILE}
)

target_link_Libraries(${name}
                      iaxclient_lib
                      ${OPENAL_LIBRARY}
                      SimGearCore
)

install(TARGETS ${name} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== test_suite/simgear_tests/props/CMakeLists.txt ===
set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/TestSuite.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/test_props.cxx
    PARENT_SCOPE
)

set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/test_props.hxx
    PARENT_SCOPE
)

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               flightgear-data-ai (>= 1:2020.3.18~),
-               flightgear-data-base (>= 1:2020.3.18~),
+               flightgear-data-ai (>= 1:2020.3.19~),
+               flightgear-data-base (>= 1:2020.3.19~),
                flite1-dev,
                libboost-dev,
                libcurl4-gnutls-dev,
@@ -24,7 +24,7 @@
                libplib-dev,
                libqt5svg5-dev,
                libsimgear-dev (<= 1:2020.3.999),
-               libsimgear-dev (>> 1:2020.3.18~),
+               libsimgear-dev (>= 1:2020.3.19~),
                libspeex-dev,
                libspeexdsp-dev,
                libsqlite3-dev,
@@ -38,7 +38,7 @@
                qtdeclarative5-private-dev [!armel !armhf],
                qttools5-dev,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/flightgear
 Vcs-Git: https://salsa.debian.org/debian/flightgear.git
 Homepage: https://home.flightgear.org/
@@ -46,7 +46,7 @@
 
 Package: flightgear
 Architecture: any
-Depends: flightgear-data-all (>= 1:2020.3.18~),
+Depends: flightgear-data-all (>= 1:2020.3.19~),
          qml-module-qtquick-window2 [!armel !armhf],
          qml-module-qtquick2 [!armel !armhf],
          ${misc:Depends},

## flightgear 2024.1.3%2Bdfsg

=== test_suite/unit_tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: (C) 2016  Edware d'Auvergne
# SPDX-License-Identifier: GPL-2.0-or-later

# Add each unit test category.
foreach( unit_test_category
        Add-ons
        Aircraft
        general
        FDM
        Input
        Main
        Navaids
        Network
        Instrumentation
        Scripting
        AI
        Airports
        Autopilot
    )

    add_subdirectory(${unit_test_category})

endforeach( unit_test_category )


set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    PARENT_SCOPE
)


set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    PARENT_SCOPE
)

=== test_suite/unit_tests/Aircraft/CMakeLists.txt ===
# SPDX-FileCopyrightText: (C) 2025  James Turner <james@flightgear.org>
# SPDX-License-Identifier: GPL-2.0-or-later

set(TESTSUITE_SOURCES
    ${TESTSUITE_SOURCES}
    ${CMAKE_CURRENT_SOURCE_DIR}/TestSuite.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/test_controls.cxx
    PARENT_SCOPE
)

set(TESTSUITE_HEADERS
    ${TESTSUITE_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/test_controls.hxx
    PARENT_SCOPE
)

## flightgear 2024.1.3%2bdfsg

=== debian/changelog ===
flightgear (1:2024.1.3+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * /usr/share/cdbs/1/rules/utils.mk is gone, please use licenserecon instead

  [ Dr. Tobias Quathamer ]
  * New upstream version 2024.1.3+dfsg (Closes: #1104647)
    - Remove patches that have been applied upstream
    - Refresh patches
    - New patch: Fix upstream test suite name
    - Update versioned Build-Dependencies to new packages
  * Update d/watch to v5
  * Update homepage
  * Remove Priority: optional from d/control
  * Update Standards-Version to 4.7.3
  * Remove Rules-Requires-Root from d/control
  * Use wrap-and-sort -astkb
  * Remove package for kfreebsd-any from Build-Depends. The port has been
    removed from Debian.
  * Update d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 17 Jan 2026 00:32:06 +0100
